﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;

namespace UserControlInRibbonGroup
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();         
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(((xamRibbon1.FindToolById("cust") as UserControlRibboTool).UserControl as RibbonToolUserControl).text1.Text);
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(((xamRibbon1.FindToolById("cust1") as UserControlRibboTool).UserControl as OtherUserControlForRibbonTool).datePicker1.SelectedDate.ToString());
        }
    }

    public class UserControlRibboTool : RibbonTool
    {
        UserControl userControl;

        protected override RibbonToolBaseControl ResolveToolControl()
        {
            return new UserControlRibboToolControl(this);
        }
        
        public UserControl UserControl
        {
            get { return userControl; }
            set { userControl = value; }
        }


    }

    public class UserControlRibboToolControl : RibbonToolBaseControl, IRibbonControl
    {
        public UserControlRibboToolControl(RibbonTool tool) : base(tool)
        {
            DefaultStyleKey = typeof(UserControlRibboToolControl);
        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            ContentControl control = GetTemplateChild("UserControlContainer") as ContentControl;
            
            if (control != null)
            {
                control.Unloaded += (s, e) =>
                    {
                        control.Content = null;
                    };
                control.Content = (Tool as UserControlRibboTool).UserControl;
            }
        }
    }

}
